as'******************************************************************************
'*  cpm.spin - demo mode for the qz80 core
'*
'*  (c) Juergen Buchmueller <pullmoll@t-online.de>
'*
'* $Id: cpm.spin,v 1.12 2010-05-15 19:55:31 pm Exp $
'******************************************************************************
CON
	_xinfreq		= 5_000_000		' Quartz is 5MHz
'	_xinfreq		= 6_500_000		' Quartz is 6.5MHz
	_clkmode		= xtal1 + pll16x	' System clock is 80MHz/96MHz

'' Define if you want to run this on the TriBladeProp #2,
'' on the RamBladeProp or on the DracBladeProp
'#define TriBladeProp
'#define RamBladeProp
#define DracBladeProp

'' Choose the CPU core you want to include
#define CPU_Z80
'#define CPU_8085

' Select your video norm
'#define NTSC
#define PAL

' Define this to have user 0 on PS/2 keyboard and VGA (or TV)
' If undefined, user 0 is on SIO port #0 and user 1 on PS/2 and VGA/TV
' User0 on the serial port is easier for downloading to CP/M via xmodem
' User0 on the VGA is for a standalone computer
#define USER0_PS2_VGA

'#define USER0_TO_PUNCH
' Define this to send all vga output also to the punch device buffer
' which is 16k in size. Read back out via ports $12 and $13




' Uncomment to emulate interrupts (NMI and IRQ)
#define INTERRUPTS

' Uncomment to support SIMH banked memory
#define BANKED_MEM

' Uncomment to count R register
#define COUNT_R

#ifdef TriBladeProp
	SI			= 31	' serial I/O pins on the TriBladeProp #2
	SO			= 30
	SI2			= -1	' no secondary SIO
	SO2			= -1
#define HAVE_KBD
	kbDpin			= 26	' Keyboard pins
	kbCpin			= 27
#define HAVE_SD
	doPin			= 9	' SD pins on the TriBladeProp #2
	clkPin			= 28
	diPin			= 8
	csPin			= 14
#undef  HAVE_TV
        tvPin                   = -1	' TV pins on the TriBladeProp #2 - none?
#undef  HAVE_VGA_HIRES
#undef  HAVE_VGA_COLOUR
	vgaPin			= -1	' VGA pins on the TriBladeProp #2 - none?
#undef  HAVE_LCD
#endif TriBladeProp

#ifdef RamBladeProp
' serial I/O pins on the RamBladeProp (secondary?)
	SI			= 23
	SO			= 22
	SI2			= -1
	SO2			= -1
#undef HAVE_KBD
	kbDpin			= -1	' Keyboard pins
	kbCpin			= -1
#define HAVE_SD
	doPin			= 24	' microSD pins on RamBladeProp
	clkPin			= 26
	diPin			= 25
	csPin			= 19
#undef  HAVE_VGA_HIRES
#undef  HAVE_VGA_COLOUR
	vgaPin			= -1	' VGA pins on the RamBladeProp - none
#undef  HAVE_TV
	tvPin			= -1	' TV pins on the RamBladeProp - none
#undef  HAVE_LCD
#endif RamBladeProp

#ifdef DracBladeProp
	SI			= 31	' serial I/O pins on the DracBladeProp
	SO			= 30
	SI2			= 25	' secondary SIO pins
	SO2			= 24
#define HAVE_KBD
	kbDpin			= 26	' Keyboard pins
	kbCpin			= 27
#define HAVE_SD
	doPin	                = 12	' SD pins on the DracBladeProp
	clkPin			= 13
	diPin			= 14
	csPin			= 15
#define HAVE_VGA_HIRES
'#define HAVE_VGA_COLOUR ' use have_vga_hires
	vgaPin			= 16	' VGA pins on the DracBladeProp - 16-23
'#define HAVE_TV
	tvPin			= 16	' TV pins on the DracBladeProp - 16-19; use 18 for the 1 pin TV out
#define HAVE_LCD
#endif DracBladeProp

  myvariable = 5

VAR
	byte	pins[12]
	long	params[3]
#ifdef INTERRUPTS
	long	irq
#endif INTERRUPTS

OBJ
	io	: "io"
#ifdef CPU_Z80
        qz80	: "qz80"
#endif CPU_Z80
#ifdef CPU_8085
        q85	: "q85"
#endif CPU_8085

PUB     main : okay
	' fill the pins array
	pins[ 0] := SI
	pins[ 1] := SO
	pins[ 2] := SI2
	pins[ 3] := SO2
	pins[ 4] := doPin
	pins[ 5] := clkPin
	pins[ 6] := diPin
	pins[ 7] := csPin
	pins[ 8] := kbDpin
	pins[ 9] := kbCpin
	pins[10] := vgaPin
	pins[11] := tvPin
#ifdef INTERRUPTS
        okay := \io.start(@pins, @irq)
#else
        okay := \io.start(@pins, 0)
#endif
	if okay < 0
		repeat

	params[0] := io.command_addr
#ifdef INTERRUPTS
	params[1] := @irq
#endif INTERRUPTS
#ifdef CPU_Z80
	io.str(string("Going to start qz80. Goodbye Spin!",13,10))
	' This call won't return as it starts in cog 0
	qz80.start(@params, 0)
#endif CPU_Z80
#ifdef CPU_8085
	io.str(string("Going to start q85. Goodbye Spin!",13,10))
	' This call won't return as it starts in cog 0
	q85.start(@params)
#endif
